config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  get 'fake_traffic_light/register'
  get 'fake_traffic_light/notify'
  get 'welcome/index'

  resources :emergency_vehicles do
    get 'activate', on: :member
    get 'start_emergency', on: :member
    get 'stop_emergency', on: :member
  end

  resources :fake_traffic_light do
    get 'register', on: :member
    get 'notify', on: :member
  end

  root 'welcome#index'
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/emergency_vehicle.rb
# frozen_string_literal: true

# Enumaration of status types allowed for EVs
class EmergencyVehicle < ApplicationRecord
  validates :status, inclusion: {
    in: %w[created pending active emergency]
  }
end

app/controllers/emergency_vehicles_controller.rb
# frozen_string_literal: true

# Emergency Vehicle Controller
class EmergencyVehiclesController < ApplicationController
  # Used to allow SUMO to use - should not be used in production!
  protect_from_forgery with: :null_session

  def index
    @emergency_vehicles = EmergencyVehicle.all
  end

  def show
    @emergency_vehicle = EmergencyVehicle.find(params[:id])
  end

  def new
    @emergency_vehicle = EmergencyVehicle.new
  end

  def edit
    @emergency_vehicle = EmergencyVehicle.find(params[:id])
  end

  def create
    @emergency_vehicle = EmergencyVehicle.new(ev_params)
    @emergency_vehicle.status = 'created'

    begin
      if @emergency_vehicle.save
        register_interscity

        @emergency_vehicle.update_columns(uuid: @emergency_vehicle.uuid,
                                          status: @emergency_vehicle.status)

        redirect_to @emergency_vehicle
      else
        render 'new'
      end
    rescue ActiveRecord::RecordNotUnique
      redirect_to emergency_vehicles_path,
                  flash: { error: "That RFId(#{@emergency_vehicle.rfid})
                                    is already registered" }
    end
  end

  def update
    @emergency_vehicle = EmergencyVehicle.find(params[:id])

    if @emergency_vehicle.update(ev_params)
      redirect_to @emergency_vehicle
    else
      render 'edit'
    end
  end

  def destroy
    @emergency_vehicle = EmergencyVehicle.find(params[:id])
    @emergency_vehicle.destroy

    redirect_to emergency_vehicles_path
  end

  def activate
    @emergency_vehicle = EmergencyVehicle.find(params[:id])

    if @emergency_vehicle.status == 'created' ||
       @emergency_vehicle.status == 'pending'
      register_interscity

      if @emergency_vehicle.uuid.nil? || @emergency_vehicle.uuid.empty?
        redirect_to emergency_vehicles_path,
                    flash: { error: 'This EV could not be
                                     activated in InterSCity' }
      else
        @emergency_vehicle.update_columns(uuid: @emergency_vehicle.uuid,
                                          status: @emergency_vehicle.status)
        redirect_to emergency_vehicles_path
      end
    else
      redirect_to emergency_vehicles_path,
                  flash: { error: 'Only EVs with created or pending status
                                   can be switched to active' }
    end
  end

  def start_emergency
    @emergency_vehicle = EmergencyVehicle.find(params[:id])

    if @emergency_vehicle.status == 'active'
      notify_traffic_lights(@emergency_vehicle, 'authorize')

      @emergency_vehicle.update_columns(status: 'emergency')

      log('Starting emergency...', __LINE__)

      redirect_to emergency_vehicles_path
    else
      redirect_to emergency_vehicles_path,
                  flash: { error: 'Only EVs with active status
                                   can be switched to emergency' }
    end
  end

  def stop_emergency
    @emergency_vehicle = EmergencyVehicle.find(params[:id])

    if @emergency_vehicle.status == 'emergency'
      notify_traffic_lights(@emergency_vehicle, 'deny')

      @emergency_vehicle.update_columns(status: 'active')

      log('Stoping emergency...', __LINE__)

      redirect_to emergency_vehicles_path
    else
      redirect_to emergency_vehicles_path,
                  flash: { error: 'Only EVs with emergency status
                                   can stop preemption' }
    end
  end

  private

  def ev_params
    params.require(:emergency_vehicle).permit(:rfid, :obs, :ev_type, :status)
  end

  def log(msg, line)
    Rails.logger.tagged('SPreS-EV') {
      Rails.logger.debug(__FILE__ + "[L#{line}]:: #{msg}")
    }
  end

  def notify_traffic_lights(ev, command)
    interscity_instance = EmergencyVehicleInterscity.new(
      uuid: ev.uuid
    )

    interscity_instance = EmergencyVehicleInterscity.new(
      interscity_instance.search_by_uuid
    )

    log("got: #{interscity_instance}", __LINE__)

    tl_in_radius = interscity_instance.discovery_resources_by_radius(
      'traffic_light_with_rfid_reader',
      3000
    )

    tl_command = []
    tl_in_radius.each do |tl|
      tl_command << {
        uuid: tl['uuid'],
        capabilities: {
          traffic_light_with_rfid_reader: {
            order: command,
            # target: tl['description']
            target: ev.uuid
          }
        }
      }
    end

    log("got tls: #{tl_in_radius}", __LINE__)
    log("tl_command: #{tl_command}", __LINE__)

    # Most important part: notify Traffic Lights to stop preemption!!!!!
    log('Here we must notify important traffic
         lights to stop preemption!', __LINE__)

    interscity_instance.notify_traffic_lights(tl_command)

    interscity_instance.send_data_with_data('ev_monitoring', command)
  end

  def register_interscity
    create_capability

    interscity_instance = EmergencyVehicleInterscity.new(
      description: @emergency_vehicle.rfid,
      status: 1,
      # change lat,lon to zero later
      lat: -23.571297,
      lon: -46.644181,
      ev_monitoring: 'ev_monitoring'
    )

    uuid = interscity_instance.search_by_description('ev_monitoring')

    log("UUID: #{uuid}", __LINE__)

    if uuid.nil? || uuid.empty?
      interscity_instance.create_resource

      if interscity_instance.uuid.nil? || interscity_instance.uuid.empty?
        @emergency_vehicle.status = 'pending'
      else
        @emergency_vehicle.status = 'active'
        @emergency_vehicle.uuid = interscity_instance.uuid
      end
    else
      @emergency_vehicle.status = 'active'
      @emergency_vehicle.uuid = uuid
    end
  end

  # Checking if specific capability is already created
  def create_capability
    capabilities_path = "#{ENV['CATALOGUER_HOST']}/capabilities/"
    capability_name = 'ev_monitoring'

    capability_data = {
      name: capability_name,
      description: 'Provides data about Emergency Vehicles, including their RFID and GPS information',
      capability_type: 'sensor'
    }

    begin
        RestClient.get(
          capabilities_path + capability_name
        )
        log("Updating capability #{capability_name}", __LINE__)
        RestClient.put(
          capabilities_path + capability_name,
          capability_data
        )
      rescue Exception => e
        if e.http_code == 404
          log("Capability #{capability_name} not found,
              trying to create it...", __LINE__)
          begin
            RestClient.post(
              capabilities_path,
              capability_data
            )
            log("Capability #{capability_name} created", __LINE__)
          rescue Exception => e
            log("Could not register capability: #{e}", __LINE__)
          end
        else
          log("Unknown error: #{e}", __LINE__)
        end
      end
  end
end

app/helpers/emergency_vehicles_helper.rb
module EmergencyVehiclesHelper
end

app/views/emergency_vehicles/edit.html.erb
<h1>Edit Emergency Vehicle</h1>

<%= form_with(model: @emergency_vehicle, local: true) do |form| %>

    <% if @emergency_vehicle.errors.any? %>
        <div id="error_explanation">
            <h2>
                <%= pluralize(@emergency_vehicle.errors.count, "error") %> prohibited this emergency vehicle from being saved:
            </h2>
            <ul>
                <% @emergency_vehicle.errors.full_messages.each do |msg| %>
                    <li><%= msg %></li>
                <% end %>
            </ul>
        </div>
    <% end %>

    <p>
        <%= form.label :rfid %>
        <%= form.text_field :rfid %>
    </p>

    <p>
        <%= form.label :ev_type %>
        <%= form.select(:ev_type, EVType::EV_TYPES) %>
    </p>

    <p>
        <%= form.label :obs %>
        <%= form.text_area :obs %>
    </p>

    <p>
        Status <%= @emergency_vehicle.status %>
    </p>        

    <p>
        <%= form.submit %>
    </p>
<% end %>

<%= link_to 'Back', emergency_vehicles_path %>

app/views/emergency_vehicles/index.html.erb
<h1>Listing Emergency Vehicles</h1>

    <% flash.each do |name, msg| %>
        <%= content_tag :div, msg, class: name %>
    <% end %>

<%= link_to 'New Emergency Vehicle', new_emergency_vehicle_path %>    

<table>
    <tr>
        <th>RFId</th>
        <th>Type</th>
        <th>UUID</th>
        <th>Status</th>
        <th colspan="5">Actions</th>
    </tr>

    <% @emergency_vehicles.each do |ev| %>
        <tr>
            <td><%= ev.rfid %></td>
            <td><%= ev.ev_type %></td>
            <td><%= ev.uuid %></td>
            <td><%= ev.status %></td>
            <td><%= link_to 'Show', emergency_vehicle_path(ev) %></td>
            <td><%= link_to 'Edit', edit_emergency_vehicle_path(ev) %></td>
            <td><%= link_to 'Destroy', emergency_vehicle_path(ev), 
                    method: :delete,
                    data: { confirm: 'Are you sure?'} %>
            <% if ev.status == 'created' || ev.status == 'pending' %>
                <td><%= link_to 'Register in InterSCity', activate_emergency_vehicle_path(ev) %></td>    
            <% end %>
            <% if ev.status == 'active' %>
                <td><%= link_to 'Start Emergency', start_emergency_emergency_vehicle_path(ev) %></td>    
            <% end %>
            <% if ev.status == 'emergency' %>
                <td><%= link_to 'Stop Emergency', stop_emergency_emergency_vehicle_path(ev) %></td>    
            <% end %>                                  
        </tr>
    <% end %>
</table>

app/views/emergency_vehicles/new.html.erb
<h1>New Emergency Vehicle</h1>

<%= form_with scope: :emergency_vehicle, url: emergency_vehicles_path, local: true do |form| %>

    <% if @emergency_vehicle.errors.any? %>
        <div id="error_explanation">
            <h2>
                <%= pluralize(@emergency_vehicle.errors.count, "error") %> prohibited this emergency vehicle from being saved:
            </h2>
            <ul>
                <% @emergency_vehicle.errors.full_messages.each do |msg| %>
                    <li><%= msg %></li>
                <% end %>
            </ul>
        </div>
    <% end %>

    <p>
        <%= form.label :rfid %>
        <%= form.text_field :rfid %>
    </p>

    <p>
        <%= form.label :ev_type %>
        <%= form.select(:ev_type, EVType::EV_TYPES) %>
    </p>

    <p>
        <%= form.label :obs %>
        <%= form.text_area :obs %>
    </p>    

    <p>
        <%= form.submit %>
    </p>
<% end %>

<%= link_to 'Back', emergency_vehicles_path %>

app/views/emergency_vehicles/show.html.erb
<p>
    <strong>RFId:</strong>
    <%= @emergency_vehicle.rfid %>
</p>

<p>
    <strong>Type:</strong>
    <%= @emergency_vehicle.ev_type %>
</p>

<p>
    <strong>UUID:</strong>
    <%= @emergency_vehicle.uuid %>
</p>

<p>
    <strong>OBS:</strong>
    <%= @emergency_vehicle.obs %>
</p>

<p>
    <strong>Status:</strong>
    <%= @emergency_vehicle.status %>
</p>

<%= link_to 'Edit', edit_emergency_vehicle_path(@emergency_vehicle) %> |
<%= link_to 'Back', emergency_vehicles_path %>